<script>
import { HorizontalScrollBar } from '@/components/common/index.vue';

export default {
  name: 'CategoriesTable',
  description:
    'This "Bring-Your-Own-Styles" component takes in the categories object as a Table prop and renders the items in a table sorted by maturity.',
  components: {
    HorizontalScrollBar,
  },
  props: {
    table: {
      type: Object,
      required: true,
      default: null,
    },
    hasIcons: {
      type: Boolean,
      required: false,
      default: false,
    },
    showScrollbar: {
      type: Boolean,
      required: false,
      default: false,
    },
  },
  data() {
    return {
      progress: 0,
      formattedTable: {
        plan: [],
        create: [],
        verify: [],
        package: [],
        secure: [],
        deploy: [],
        monitor: [],
        govern: [],
      },
    };
  },
  beforeMount() {
    this.formattedTable = {
      plan: [...this.table.plan].sort(this.sortByMaturity),
      create: [...this.table.create].sort(this.sortByMaturity),
      verify: [...this.table.verify].sort(this.sortByMaturity),
      package: [...this.table.package].sort(this.sortByMaturity),
      secure: [...this.table.secure].sort(this.sortByMaturity),
      deploy: [...this.table.deploy].sort(this.sortByMaturity),
      monitor: [...this.table.monitor].sort(this.sortByMaturity),
      govern: [...this.table.govern].sort(this.sortByMaturity),
    };
  },
  mounted() {
    const { featureTable } = this.$refs;
    featureTable.addEventListener(
      'scroll',

      function (e) {
        const { clientWidth } = e.target;
        const { scrollLeft } = e.target;
        const { scrollWidth } = e.target;

        const scrollPercent = scrollLeft / (scrollWidth - clientWidth);
        const scrollPercentRounded = Math.round(scrollPercent * 100);
        this.progress = scrollPercentRounded;
      }.bind(this),
    );
  },
  methods: {
    sortByMaturity(a, b) {
      if (
        a.maturity === 'minimal' ||
        a.maturity === 'viable' ||
        a.maturity === 'competitive' ||
        a.maturity === 'complete' ||
        a.maturity === 'lovable'
      ) {
        return -1;
      }

      if (
        b.maturity === 'minimal' ||
        b.maturity === 'viable' ||
        b.maturity === 'competitive' ||
        b.maturity === 'complete' ||
        b.maturity === 'lovable'
      ) {
        return 1;
      }

      if (a.maturity === 'planned') {
        return 1;
      }

      if (b.maturity === 'planned') {
        return -1;
      }

      return 0;
    },
    maturity(maturityLevel) {
      if (maturityLevel === 'planned') {
        return 'planned';
      }
      return 'mature';
    },
    link(marketing_page, feature_page, documentation) {
      if (marketing_page) {
        return marketing_page;
      }

      if (feature_page) {
        return feature_page;
      }

      return documentation;
    },
    icon(stage) {
      if (stage === 'govern') {
        return 'protect-light';
      }
      if (stage === 'deploy') {
        return 'release-light';
      }
      return `${stage}-light`;
    },
    showCompetitor(stage) {
      switch (stage) {
        case 'plan':
          return 'Jira';
        case 'create':
          return 'GitHub';
        case 'verify':
          return 'Jenkins';
        case 'secure':
          return 'Snyk';
        case 'package':
          return 'JFrog';
        case 'deploy':
          return 'Harness';
        case 'monitor':
          return 'Sentry';
        case 'compliance' || 'govern':
          return null;
        default:
          return null;
      }
    },
  },
};
</script>

<template>
  <SlpContainer>
    <div ref="featureTable" class="table">
      <div v-for="category in table" :key="category[0].stage" class="column">
        <div class="sub-column-wrapper">
          <div class="sub-column">
            <div
              :class="`stage-name ${
                category[0].stage == 'govern' ? 'last' : ''
              }`"
            >
              <SlpIcon
                v-if="hasIcons"
                class="slp-mb-8"
                :name="icon(category[0].stage)"
                variant="marketing"
                alt=""
                aria-hidden="true"
                size="md"
                slp-color="primary-200"
              />
              <a :href="`/features?stage=${category[0].stage.toLowerCase()}`">
                <!-- PATCH until categories file is properly changed to Compliance-->
                {{
                  category[0].stage === 'govern'
                    ? 'Compliance'
                    : category[0].stage
                }}
              </a>
            </div>
            <div class="features">
              <span
                v-for="feature in formattedTable[category[0].stage]"
                :key="feature.name"
                :aria-describedby="`${maturity(feature.maturity)}-feature`"
              >
                <!-- Generate links to marketing_page > feature_page > documentation (in purple according to key) for mature features -->
                <a
                  v-if="
                    maturity(feature.maturity) === 'mature' &&
                    (feature.marketing_page ||
                      feature.feature_page ||
                      feature.documentation)
                  "
                  :href="
                    link(
                      feature.marketing_page,
                      feature.feature_page,
                      feature.documentation,
                    )
                  "
                  :data-ga-name="feature.name"
                  data-ga-location="feature table"
                  :class="maturity(feature.maturity)"
                >
                  {{ feature.name }}
                </a>

                <!-- Generate links to direction page (in white according to key) for features that are planned -->
                <a
                  v-else-if="
                    maturity(feature.maturity) === 'planned' &&
                    feature.direction
                  "
                  :href="feature.direction"
                  :data-ga-name="feature.name"
                  data-ga-location="feature table"
                  :class="maturity(feature.maturity)"
                  style="color: #ffffff"
                >
                  {{ feature.name }}
                </a>
              </span>
            </div>
          </div>
          <div
            class="competitor"
            :class="showCompetitor(category[0].stage) ? 'has-competitor' : ''"
          >
            <p v-if="showCompetitor(category[0].stage)">
              <span class="competitor__label">Replacement for</span>
              <SlpTypography
                tag="span"
                variant="body3-bold"
                class="competitor__company"
                >{{ showCompetitor(category[0].stage) }}</SlpTypography
              >
            </p>
          </div>
        </div>
      </div>
    </div>
    <HorizontalScrollBar
      v-if="showScrollbar"
      class="horizontal-scroll"
      :value="progress"
    />
  </SlpContainer>
</template>

<style lang="scss" scoped>
::-webkit-scrollbar {
  display: none;
}

.horizontal-scroll {
  display: none;

  @media (max-width: 1023px) {
    display: block;
  }
}

.table {
  @media (max-width: $breakpoint-lg) {
    overflow-x: auto;
  }

  @media (min-width: $breakpoint-lg) {
    .column {
      width: 13%;
    }
  }

  .stage-name {
    text-transform: capitalize;
    display: block;
    position: relative;

    a {
      color: inherit;
      &:hover {
        text-decoration: underline;
      }
    }
  }

  .features a,
  .features p {
    display: block;
  }

  .features a:hover {
    text-decoration: underline;
  }

  .column {
    .competitor {
      border-left: 1px solid #45424d;
    }
  }

  .column:first-of-type {
    .competitor {
      border-left: 1px solid transparent;
    }
  }

  .column:last-of-type {
    .competitor {
      height: 88px;
    }
  }

  .competitor {
    padding: 24px 12px;
    text-align: center;
    border-top: 1px solid #45424d;

    &__label {
      display: block;
      font-size: 11px;
      line-height: 15px;
      text-align: center;
      color: $color-surface-400;
    }

    &__company {
      color: #a2a1a6;
    }
  }
}
</style>
